/* testing BSF's sleep function */

if rxFuncQuery("BSF") then  /* no bsf4rexx support available yet, hence load Java */
do
   call rxFuncAdd "BsfLoadFuncs", "BSF4Rexx", "BsfLoadFuncs"
   call BsfLoadFuncs    /* load all BSF-functions                    */
   call BsfLoadJava     /* load the JVM and set up BSF4Rexx-support  */
end

if      BsfInvokedBy()=1 then say "[This Rexx program was invoked by Java!]"
else if BsfInvokedBy()=2 then say "[This Rexx program was invoked by Rexx, JVM loaded by Rexx!]"
else                          say "[No JVM present, we got troubles ...]"

        /* set some seconds to sleep ...        */

i=0
i=i+1; a.i =    0         ; a.i.msecs = 0
i=i+1; a.i =    1         ; a.i.msecs = 1000
i=i+1; a.i =     .1       ; a.i.msecs =  100
i=i+1; a.i =     .01      ; a.i.msecs =   10
i=i+1; a.i =     .001     ; a.i.msecs =    1
i=i+1; a.i =     .0001    ; a.i.msecs =    0
i=i+1; a.i =    1.987654  ; a.i.msecs = 1988
i=i+1; a.i =    1.001     ; a.i.msecs = 1001
i=i+1; a.i =    1.01      ; a.i.msecs = 1010
i=i+1; a.i =    1.1       ; a.i.msecs = 1100
a.0        = i;

PARSE VERSION version
PARSE SOURCE source
say "running the following Rexx interpreter: ["version"]"
say "parse source yields: ["source"]"
say

l=length(a.0)
tab="09"x
do i=1 to a.0
   say right(i,l)"/"right(a.0,l) "- rexx: sleeping (via Java)" right(a.i.msecs,5) "ms (rounded from:" tab a.i "secs)"
   call time 'r'                /* reset timer                          */
   call bsf "sleep", a.i
   time = time('r')             /* reset timer, receive elapsed time    */
   say tab tab tab tab tab tab "elapsed time:" tab format(time, , 3) "secs"
   say
end

